#include <allegro.h>      /* Allegro rules!!! */
#include <string.h>
#include <stdio.h>
#include "edop.h"
#include "ymw.h"
#include "FileIO.h"
#include "mem.h"
#include "gfxhelp.h"
#include "ColorPicker.h"
#include "ObjectDialog.h"
#include "find.h"

#include "lists.h"

#define d_rtext_proc d_text_proc

char *object_lister( int index, int *list_size );
int object_list_proc( int msg, DIALOG *d, int c );
char *object_type_lister( int index, int *list_size );
char *object_ebv_lister( int index, int *list_size );
int object_ebv_list_proc( int msg, DIALOG *d, int c );
char *object_wbv_lister( int index, int *list_size );
int object_wbv_list_proc( int msg, DIALOG *d, int c );
int weight_edit_proc( int msg, DIALOG *d, int c );
int cost_edit_proc( int msg, DIALOG *d, int c );
int rent_edit_proc( int msg, DIALOG *d, int c );
char *obj_exd_lister( int index, int *list_size );
char *object_affect_lister( int index, int *list_size );
int object_affect_list_proc( int msg, DIALOG *d, int c );
char *object_affects_lister( int index, int *list_size );
int object_affects_list_proc( int msg, DIALOG *d, int c );
int af_value_edit_proc( int msg, DIALOG *d, int c );
int obj_exd_list_proc( int msg, DIALOG *d, int c );
int exd_kword_edit_proc( int msg, DIALOG *d, int c );
char *spell_lister( int index, int *list_size );
char *damage_message_lister( int index, int *list_size );
char *container_bvl( int index, int *list_size );
char *key_lister( int index, int *list_size );
char *liquid_lister( int index, int *list_size );
int object_type_list_proc( int msg, DIALOG *d, int c );
int object_type_label( int msg, DIALOG *d, int c );
int d_mydroplistbutton_proc( int msg, DIALOG *d, int c );
int value_numeral_edit_proc( int msg, DIALOG *d, int c );
int object_type_proc( int msg, DIALOG *d, int c );
int obj_shdesc_proc( int msg, DIALOG *d, int c );
int obj_ed_refresher( int msg, DIALOG *d, int c );

MENU menu_object_list[]=
{
   /* text,             proc,           child,      flags, dp */
    { "&Create new",    NULL,           NULL,       0,     NULL },
    { "&Edit",          NULL,           NULL,       0,     NULL },
    { "&Delete",        NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

MENU obj_exd_menu[]=
{
   /* text,             proc,           child,      flags, dp */
    { "&Create new",    NULL,           NULL,       0,     NULL },
    { "&Delete",        NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

MENU menu_object_affect_list[]=
{
   /* text,             proc,           child,      flags, dp */
    { "&Create new",    NULL,           NULL,       0,     NULL },
    { "&Delete",        NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

DIALOG obj_ed_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,                      dp2,      dp3 */
/*00*/{ obj_ed_refresher,        0,   0,   0,   0,   0,   0,   0,   0,      0,          0,  NULL,                    NULL,     NULL },
/*01*/{ d_shadow_box_proc,       0,   0,   540, 365, CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     NULL },
/*02*/{ d_ctext_proc,            80,  5,   0,   8,   CTX, CFG, 0,   0,      0,          0,  "Objects",               NULL,     NULL },
/*03*/{ object_list_proc,        5,   14,  160, 62,  CTX, CFG, 0,   0,      0,          0,  object_lister,           NULL,     NULL },
/*04*/{ d_text_proc,             304, 5,   96,  8,   CTX, CFG, 0,   0,      0,          0,  "Descriptions",          NULL,     NULL },
/*05*/{ d_text_proc,             170, 14,  88,  8,   CTX, CFG, 0,   0,      0,          0,  "Short:",                NULL,     NULL },
/*06*/{ obj_shdesc_proc,         265, 14,  267, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  NULL,                    NULL,     NULL },
/*07*/{ d_text_proc,             170, 23,  88,  8,   CTX, CFG, 0,   0,      0,          0,  "Long:",                 NULL,     NULL },
/*08*/{ d_edit_proc,             265, 23,  267, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  NULL,                    NULL,     NULL },
/*09*/{ d_text_proc,             170, 32,  88,  8,   CTX, CFG, 0,   0,      0,          0,  "Action:",               NULL,     NULL },
/*10*/{ d_edit_proc,             265, 32,  267, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  NULL,                    NULL,     NULL },
/*11*/{ d_text_proc,             170, 41,  88,  8,   CTX, CFG, 0,   0,      0,          0,  "Keywords:",             NULL,     NULL },
/*12*/{ d_edit_proc,             265, 41,  267, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  NULL,                    NULL,     NULL },
/*13*/{ d_text_proc,             170, 50,  88,  8,   CTX, CFG, 0,   0,      0,          0,  "Weight:",               NULL,     NULL },
/*14*/{ weight_edit_proc,        265, 50,  267, 8,   CTX, CBD, 0,   0,      10,         0,  "Weight####",            NULL,     NULL },
/*15*/{ d_text_proc,             170, 59,  88,  8,   CTX, CFG, 0,   0,      0,          0,  "Cost:",                 NULL,     NULL },
/*16*/{ cost_edit_proc,          265, 59,  267, 8,   CTX, CBD, 0,   0,      10,         0,  "Cost######",            NULL,     NULL },
/*17*/{ d_text_proc,             170, 68,  88,  8,   CTX, CFG, 0,   0,      0,          0,  "Rent:",                 NULL,     NULL },
/*18*/{ rent_edit_proc,          265, 68,  267, 8,   CTX, CBD, 0,   0,      10,         0,  "Rent######",            NULL,     NULL },
/*19*/{ d_ctext_proc,            89,  77,  0,   8,   CTX, CFG, 0,   0,      0,          0,  "Type",                  NULL,     NULL },
/*20*/{ object_type_list_proc,   5,   86,  173, 68,  CTX, CFG, 0,   0,      0,          0,  object_type_lister,      NULL,     NULL },
/*21*/{ d_ctext_proc,            267, 77,  0,   8,   CTX, CFG, 0,   0,      0,          0,  "Effects",               NULL,     NULL },
/*22*/{ object_ebv_list_proc,    183, 86,  173, 68,  CTX, CFG, 0,   0,      0,          0,  object_ebv_lister,       NULL,     NULL },
/*23*/{ d_ctext_proc,            445, 77,  0,   8,   CTX, CFG, 0,   0,      0,          0,  "Wear",                  NULL,     NULL },
/*24*/{ object_wbv_list_proc,    361, 86,  173, 68,  CTX, CFG, 0,   0,      0,          0,  object_wbv_lister,       NULL,     NULL },
/*25*/{ object_type_label,       5,   157, 192, 8,   CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(0) },
/*26*/{ object_type_proc,        221, 155, 192, 12,  CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(0) },
/*27*/{ object_type_label,       5,   171, 192, 8,   CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(1) },
/*28*/{ object_type_proc,        221, 169, 192, 12,  CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(1) },
/*29*/{ object_type_label,       5,   185, 192, 8,   CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(2) },
/*30*/{ object_type_proc,        221, 183, 192, 12,  CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(2) },
/*31*/{ object_type_label,       5,   199, 192, 8,   CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(3) },
/*32*/{ object_type_proc,        221, 197, 192, 12,  CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(3) },
/*33*/{ d_ctext_proc,            101, 211, 192, 8,   CTX, CFG, 0,   0,      0,          0,  "Descriptions:",         NULL,     NULL },
/*34*/{ obj_exd_list_proc,       5,   220, 192, 44,  CTX, CFG, 0,   0,      0,          0,  obj_exd_lister,          NULL,     NULL },
/*35*/{ d_text_proc,             202, 211, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Keywords:",             NULL,     NULL },
/*36*/{ exd_kword_edit_proc,     218, 220, 317, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                NULL,     NULL },
/*37*/{ d_text_proc,             202, 229, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Description:",          NULL,     NULL },
/*38*/{ d_edit_proc,             218, 238, 317, 8,   CTX, CBD, 0,   0,      RDSIZE,     0,  blankstr,                NULL,     NULL },
/*39*/{ d_ctext_proc,            270, 267, 0,   8,   CTX, CFG, 0,   0,      0,          0,  "Object Affects",        NULL,     NULL },
/*40*/{ object_affect_list_proc, 5,   276, 530, 36,  CTX, CFG, 0,   0,      0,          0,  object_affect_lister,    NULL,     NULL },
/*41*/{ d_ctext_proc,            137, 315, 0,   8,   CTX, CFG, 0,   0,      0,          0,  "Apply to...",           NULL,     NULL },
/*42*/{ object_affects_list_proc,5,   324, 265, 36,  CTX, CFG, 0,   0,      0,          0,  object_affects_lister,   NULL,     NULL },
/*43*/{ d_ctext_proc,            407, 315, 0,   8,   CTX, CFG, 0,   0,      0,          0,  "By amount...",          NULL,     NULL },
/*44*/{ af_value_edit_proc,      275, 324, 260, 8,   CTX, CBD, 0,   0,      10,         0,  "ObjAfValue",            NULL,     NULL },
/*45*/{ d_button_proc,           405, 335, 130, 25,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Return",                NULL,     NULL },
standarnd_dialog_chunks
};

DIALOG object_droplist_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,                      dp2,              dp3 */
/*00*/{ d_list_proc,             0,   0,   192, 76,  CTX, CFG, 0,   D_EXIT, -1,         0,  NULL,                    NULL,             NULL },
standarnd_dialog_chunks
};

char object_type_labels[23][4][23]=
{            /* (label 1),                (label 2),                (label 3),                (label 4) */
/*Light     */{ "",                       "",                       "Capacity in hours:",     "" },
/*Scroll    */{ "Level:",                 "Spell 1:",               "Spell 2:",               "Spell 3:" },
/*Wand      */{ "Level:",                 "Charge Capacity:",       "Charges Left:",          "Spell:" },
/*Staff     */{ "Level:",                 "Charge Capacity:",       "Charges Left:",          "Spell:" },
/*Weapon    */{ "",                       "Number of damage dice:", "Size of damage dice:",   "Damage messages:" },
/*FireWeapon*/{ "",                       "",                       "",                       "" },
/*Missile   */{ "",                       "",                       "",                       "" },
/*Treasure  */{ "",                       "",                       "",                       "" },
/*Armor     */{ "AC Apply:",              "",                       "",                       "" },
/*Potion    */{ "Level:",                 "Spell 1:",               "Spell 2:",               "Spell 3:" },
/*Worn      */{ "",                       "",                       "",                       "" },
/*Other     */{ "",                       "",                       "",                       "" },
/*Trash     */{ "",                       "",                       "",                       "" },
/*Trap      */{ "",                       "",                       "",                       "" },
/*Container */{ "Weight capacity:",       "Type:",                  "Key object:",            "" },
/*Note      */{ "Language:",              "",                       "",                       "" },
/*DrinkCon  */{ "Capacity of container:", "Quantity in container:", "Liquid type:",           "Poisoned:" },
/*Key       */{ "",                       "",                       "",                       "" },
/*Food      */{ "Hours satisfied:",       "",                       "",                       "Poisoned:" },
/*Money     */{ "Number of gold coins:",  "",                       "",                       "" },
/*Pen       */{ "",                       "",                       "",                       "" },
/*Boat      */{ "",                       "",                       "",                       "" },
/*Fountain  */{ "Capacity of fountain:",  "Quantity in fountain:",  "Liquid type:",           "Poisoned:" },
};

#define OTP_NU               0
#define OTP_NUM              1
#define OTP_DROPLIST         2
#define OTP_DROPCHECK        3
#define OTP_CHECK            4
#define OTP_OBJPICKER        5

int object_type_procs[23][4]=
{            /* (type 1),      (type 2),      (type 3),      (type 4) */
/*Light     */{ OTP_NU,        OTP_NU,        OTP_NUM,       OTP_NU },
/*Scroll    */{ OTP_NUM,       OTP_DROPLIST,  OTP_DROPLIST,  OTP_DROPLIST },
/*Wand      */{ OTP_NUM,       OTP_NUM,       OTP_NUM,       OTP_DROPLIST },
/*Staff     */{ OTP_NUM,       OTP_NUM,       OTP_NUM,       OTP_DROPLIST },
/*Weapon    */{ OTP_NU,        OTP_NUM,       OTP_NUM,       OTP_DROPLIST },
/*FireWeapon*/{ OTP_NU,        OTP_NU,        OTP_NU,        OTP_NU },
/*Missile   */{ OTP_NU,        OTP_NU,        OTP_NU,        OTP_NU },
/*Treasure  */{ OTP_NU,        OTP_NU,        OTP_NU,        OTP_NU },
/*Armor     */{ OTP_NUM,       OTP_NU,        OTP_NU,        OTP_NU },
/*Potion    */{ OTP_NUM,       OTP_DROPLIST,  OTP_DROPLIST,  OTP_DROPLIST },
/*Worn      */{ OTP_NU,        OTP_NU,        OTP_NU,        OTP_NU },
/*Other     */{ OTP_NU,        OTP_NU,        OTP_NU,        OTP_NU },
/*Trash     */{ OTP_NU,        OTP_NU,        OTP_NU,        OTP_NU },
/*Trap      */{ OTP_NU,        OTP_NU,        OTP_NU,        OTP_NU },
/*Container */{ OTP_NUM,       OTP_DROPCHECK, OTP_OBJPICKER, OTP_NU },
/*Note      */{ OTP_NU,        OTP_NU,        OTP_NU,        OTP_NU },
/*DrinkCon  */{ OTP_NUM,       OTP_NUM,       OTP_DROPLIST,  OTP_CHECK },
/*Key       */{ OTP_NU,        OTP_NU,        OTP_NU,        OTP_NU },
/*Food      */{ OTP_NUM,       OTP_NU,        OTP_NU,        OTP_CHECK },
/*Money     */{ OTP_NUM,       OTP_NU,        OTP_NU,        OTP_NU },
/*Pen       */{ OTP_NU,        OTP_NU,        OTP_NU,        OTP_NU },
/*Boat      */{ OTP_NU,        OTP_NU,        OTP_NU,        OTP_NU },
/*Fountain  */{ OTP_NUM,       OTP_NUM,       OTP_DROPLIST,  OTP_CHECK },
};

void *object_type_proc_data[23][4]=
{
/*Light     */{ NULL,          NULL,          "0",           NULL },
/*Scroll    */{ "1",           spell_lister,  spell_lister,  spell_lister },
/*Wand      */{ "1",           "3",           "3",           spell_lister },
/*Staff     */{ "1",           "3",           "3",           spell_lister },
/*Weapon    */{ NULL,          "2",           "3",           damage_message_lister },
/*FireWeapon*/{ NULL,          NULL,          NULL,          NULL },
/*Missile   */{ NULL,          NULL,          NULL,          NULL },
/*Treasure  */{ NULL,          NULL,          NULL,          NULL },
/*Armor     */{ "5",           NULL,          NULL,          NULL },
/*Potion    */{ "1",           spell_lister,  spell_lister,  spell_lister },
/*Worn      */{ NULL,          NULL,          NULL,          NULL },
/*Other     */{ NULL,          NULL,          NULL,          NULL },
/*Trash     */{ NULL,          NULL,          NULL,          NULL },
/*Trap      */{ NULL,          NULL,          NULL,          NULL },
/*Container */{ "20",          container_bvl, key_lister,    NULL },
/*Note      */{ NULL,          NULL,          NULL,          NULL },
/*DrinkCon  */{ "5",           "5",           liquid_lister, "Poisoned" },
/*Key       */{ NULL,          NULL,          NULL,          NULL },
/*Food      */{ "6",           NULL,          NULL,          "Poisoned" },
/*Money     */{ "30",          NULL,          NULL,          NULL },
/*Pen       */{ NULL,          NULL,          NULL,          NULL },
/*Boat      */{ NULL,          NULL,          NULL,          NULL },
/*Fountain  */{ "500",         "500",         liquid_lister, "Poisoned" },
};

char *object_lister( int index, int *list_size )
{
    static char tmp[22];

    if( index < 0 ){
      *list_size = world.zone[cur_zone].num_objects;
      return "";
      }

    tmp[21] = '\0';
    strncpy( &tmp[1], world.zone[cur_zone].object[index].short_desc, 20 );
    if( index == cur_object ){
      tmp[0] = '';
      }
    else{
      tmp[0] = ' ';
      }

    return tmp;
}

int object_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( msg == MSG_CLICK ){
      if( mmb & 2 ){
        if( world.zone[cur_zone].num_objects < 1 ){
          menu_object_list[1].flags |= D_DISABLED;
          menu_object_list[2].flags |= D_DISABLED;
          }
        else{
          menu_object_list[1].flags &= ~D_DISABLED;
          menu_object_list[2].flags &= ~D_DISABLED;
          }
        switch( do_menu( menu_object_list, mouse_x, mouse_y ) ){
          case 0:
               cur_object = add_object( &world.zone[cur_zone] );
               d->d1 = cur_object;
               return D_REDRAW;
               break;

          case 1:
               cur_object = d->d1;
               return D_REDRAW;
               break;

          case 2:
               del_object( &world.zone[cur_zone], d->d1 );
               if( d->d1 >= world.zone[cur_zone].num_objects ){
                 d->d1 = world.zone[cur_zone].num_objects-1;
                 }
               return D_REDRAW;
               break;
          }
        }
      }
    else if( msg == MSG_DCLICK ){
      if( world.zone[cur_zone].num_objects > 0 ){
        cur_object = d->d1;
        }
      return D_REDRAW;
      }

    return ret;
}

char *object_type_lister( int index, int *list_size )
{
    static char tmp[22];

    if( index < 0 ){
      *list_size = 23;
      return "";
      }

    tmp[21] = '\0';
    strncpy( &tmp[1], object_type_list[index], 20 );
    if( (unsigned int)(index) == world.zone[cur_zone].object[cur_object].type ){
      tmp[0] = '';
      }
    else{
      tmp[0] = ' ';
      }

    return tmp;
}

char *object_ebv_lister( int index, int *list_size )
{
    static char tmp[22];

    if( index < 0 ){
      *list_size = 17;
      return "";
      }

    tmp[21] = '\0';
    strncpy( &tmp[1], object_ebv_list[index], 20 );
    if( ((1<<index)&world.zone[cur_zone].object[cur_object].ebv) ){
      tmp[0] = '';
      }
    else{
      tmp[0] = ' ';
      }

    return tmp;
}

int object_ebv_list_proc( int msg, DIALOG *d, int c )
{
    int ret = d_list_proc( msg, d, c );
//    int j;

    if( cur_object > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_USER ){
        }
  
      if( msg == MSG_DCLICK ){
        if( ((1<<d->d1)&world.zone[cur_zone].object[cur_object].ebv) ){
          world.zone[cur_zone].object[cur_object].ebv = world.zone[cur_zone].object[cur_object].ebv&(~(1<<d->d1));
          }
        else{
          world.zone[cur_zone].object[cur_object].ebv = world.zone[cur_zone].object[cur_object].ebv|(1<<d->d1);
          }
        d->proc( MSG_DRAW, d, 0 );
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }


    return ret;
}

char *object_wbv_lister( int index, int *list_size )
{
    static char tmp[22];

    if( index < 0 ){
      *list_size = 15;
      return "";
      }

    tmp[21] = '\0';
    strncpy( &tmp[1], object_wbv_list[index], 20 );
    if( ((1<<index)&world.zone[cur_zone].object[cur_object].wbv) ){
      tmp[0] = '';
      }
    else{
      tmp[0] = ' ';
      }

    return tmp;
}

int object_wbv_list_proc( int msg, DIALOG *d, int c )
{
    int ret = d_list_proc( msg, d, c );
//    int j;

    if( cur_object > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_USER ){
        }
  
      if( msg == MSG_DCLICK ){
        if( ((1<<d->d1)&world.zone[cur_zone].object[cur_object].wbv) ){
          world.zone[cur_zone].object[cur_object].wbv = world.zone[cur_zone].object[cur_object].wbv&(~(1<<d->d1));
          }
        else{
          world.zone[cur_zone].object[cur_object].wbv = world.zone[cur_zone].object[cur_object].wbv|(1<<d->d1);
          }
        d->proc( MSG_DRAW, d, 0 );
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }


    return ret;
}

int weight_edit_proc( int msg, DIALOG *d, int c )
{
    int ret=D_O_K;

    if( msg == MSG_UCHAR ){
      if ((c >= '0') && (c <= '9')) {
        ret = d_edit_proc( msg, d, c );
        }
      }
    else{
      ret = d_edit_proc( msg, d, c );
      }

    if( ret == D_USED_CHAR ){
      world.zone[cur_zone].object[cur_object].weight = atoi( d->dp );
      }

    return ret;
}

int cost_edit_proc( int msg, DIALOG *d, int c )
{
    int ret=D_O_K;

    if( msg == MSG_UCHAR ){
      if ((c >= '0') && (c <= '9')) {
        ret = d_edit_proc( msg, d, c );
        }
      }
    else{
      ret = d_edit_proc( msg, d, c );
      }

    if( ret == D_USED_CHAR ){
      world.zone[cur_zone].object[cur_object].cost = atoi( d->dp );
      }

    return ret;
}

int rent_edit_proc( int msg, DIALOG *d, int c )
{
    int ret=D_O_K;

    if( msg == MSG_UCHAR ){
      if ((c >= '0') && (c <= '9')) {
        ret = d_edit_proc( msg, d, c );
        }
      }
    else{
      ret = d_edit_proc( msg, d, c );
      }

    if( ret == D_USED_CHAR ){
      world.zone[cur_zone].object[cur_object].rpd = atoi( d->dp );
      }

    return ret;
}

char *obj_exd_lister( int index, int *list_size )
{
    if( index < 0 ){
      if( cur_object < 0 )
        *list_size = 0;
      else
        *list_size = world.zone[cur_zone].object[cur_object].num_exd;
      return NULL;
      }

    return world.zone[cur_zone].object[cur_object].exd[index].keywords;
}

char *object_affect_lister( int index, int *list_size )
{
    static char tmp[100];
     
    if( index < 0 ){
      if( cur_object < 0 )
        *list_size = 0;
      else
        *list_size = world.zone[cur_zone].object[cur_object].num_affect;
      return "";
      }

    memset( tmp, 0, 100 );
    sprintf( tmp, "Affect %s by %d.", object_affects_list[world.zone[cur_zone].object[cur_object].affect[index].location], world.zone[cur_zone].object[cur_object].affect[index].value );

    return tmp;
}

int object_affect_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( cur_object > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_CLICK ){
        if( mmb & 2 ){
          if( world.zone[cur_zone].object[cur_object].num_affect < 1 ){
            menu_object_affect_list[1].flags |= D_DISABLED;
            }
          else{
            menu_object_affect_list[1].flags &= ~D_DISABLED;
            }
          switch( do_menu( menu_object_affect_list, mouse_x, mouse_y ) ){
            case 0:
                 d->d1 = add_object_affect( &world.zone[cur_zone].object[cur_object] );
                 d->proc( MSG_DRAW, d, 0 );
                 break;

            case 1:
                 del_object_affect( &world.zone[cur_zone].object[cur_object], d->d1 );
                 d->d1 = 0;
                 d->proc( MSG_DRAW, d, 0 );
                 break;
            }
          }

        obj_ed_dlg[0].proc(  MSG_DRAW, &obj_ed_dlg[0],  0 );
        obj_ed_dlg[42].proc( MSG_DRAW, &obj_ed_dlg[42], 0 );
        obj_ed_dlg[44].proc( MSG_DRAW, &obj_ed_dlg[44], 0 );
        return D_O_K;
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

char *object_affects_lister( int index, int *list_size )
{
    static char tmp[30];

    if( index < 0 ){
      *list_size = 25;
      return "";
      }

    tmp[29] = '\0';
    strncpy( &tmp[1], object_affects_list[index], 27 );
    if( index == world.zone[cur_zone].object[cur_object].affect[obj_ed_dlg[40].d1].location ){
      tmp[0] = '';
      }
    else{
      tmp[0] = ' ';
      }

    return tmp;
}

int object_affects_list_proc( int msg, DIALOG *d, int c )
{
    int ret = d_list_proc( msg, d, c );
//    int j;

    if( cur_object > -1 ){
      if( world.zone[cur_zone].object[cur_object].num_affect > 0 ){
        if( (D_DISABLED&d->flags) ){
          d->flags = d->flags&(~(D_DISABLED));
          d->proc( MSG_DRAW, d, 0 );
          }
        }
      else{
        if( !(D_DISABLED&d->flags) ){
          d->flags = d->flags|D_DISABLED;
          d->proc( MSG_DRAW, d, 0 );
          }
        }
  
      if( msg == MSG_DCLICK ){
        world.zone[cur_zone].object[cur_object].affect[obj_ed_dlg[40].d1].location = d->d1;
        d->proc( MSG_DRAW, d, 0 );
        obj_ed_dlg[40].proc( MSG_DRAW, &obj_ed_dlg[40], 0 );
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }


    return ret;
}

int af_value_edit_proc( int msg, DIALOG *d, int c )
{
    int ret=D_O_K;

    if( msg == MSG_UCHAR ){
      if (((c >= '0') && (c <= '9')) || (c == '-')) {
        ret = d_edit_proc( msg, d, c );
        }
      }
    else{
      ret = d_edit_proc( msg, d, c );
      }

    if( ret == D_USED_CHAR ){
      world.zone[cur_zone].object[cur_object].affect[obj_ed_dlg[40].d1].value = atoi( d->dp );
      obj_ed_dlg[40].proc( MSG_DRAW, &obj_ed_dlg[40], 0 );
      }

    if( cur_object > -1 ){
      if( world.zone[cur_zone].object[cur_object].num_affect > 0 ){
        if( (D_DISABLED&d->flags) ){
          d->flags = d->flags&(~(D_DISABLED));
          d->proc( MSG_DRAW, d, 0 );
          }
        }
      else{
        if( !(D_DISABLED&d->flags) ){
          d->flags = d->flags|D_DISABLED;
          d->proc( MSG_DRAW, d, 0 );
          }
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

int obj_exd_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( cur_object > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_CLICK ){
        if( mmb & 2 ){
          if( world.zone[cur_zone].object[cur_object].num_exd < 1 ){
            obj_exd_menu[1].flags |= D_DISABLED;
            }
          else{
            obj_exd_menu[1].flags &= ~D_DISABLED;
            }
          switch( do_menu( obj_exd_menu, mouse_x, mouse_y ) ){
            case 0:
                 d->d1 = add_object_exd( &world.zone[cur_zone].object[cur_object] );
                 d->proc( MSG_DRAW, d, 0 );
                 break;

            case 1:
                 del_object_exd( &world.zone[cur_zone].object[cur_object], d->d1 );
                 d->d1 = 0;
                 d->proc( MSG_DRAW, d, 0 );
                 break;
            }
          }

        obj_ed_dlg[0].proc(  MSG_DRAW, &obj_ed_dlg[0],  0 );
        obj_ed_dlg[36].proc( MSG_DRAW, &obj_ed_dlg[36], 0 );
        obj_ed_dlg[38].proc( MSG_DRAW, &obj_ed_dlg[38], 0 );
        return D_O_K;
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

int exd_kword_edit_proc( int msg, DIALOG *d, int c )
{
    int ret;

    ret = d_edit_proc( msg, d, c );

    if( cur_object > -1 ){
      if( world.zone[cur_zone].object[cur_object].num_exd > 0 ){
        if( (D_DISABLED&d->flags) ){
          d->flags = d->flags&(~(D_DISABLED));
          d->proc( MSG_DRAW, d, 0 );
          }
  
        if( ret == D_USED_CHAR ){
          obj_ed_dlg[34].proc( MSG_DRAW, &obj_ed_dlg[34], 0 );
          }
        }
      else{
        if( !(D_DISABLED&d->flags) ){
          d->flags = d->flags|D_DISABLED;
          d->proc( MSG_DRAW, d, 0 );
          }
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

char *spell_lister( int index, int *list_size )
{
    if( index < 0 ){
      *list_size = 53;
      return NULL;
      }

    return spell_list[index];
}

char *damage_message_lister( int index, int *list_size )
{
    if( index < 0 ){
      *list_size = 15;
      return NULL;
      }

    return damage_message_list[index];
}

char *container_bvl( int index, int *list_size )
{
    static char temp[21]="";

    if( index < 0 ){
      *list_size = 4;
      return NULL;
      }

    strncpy( &temp[1], container_bv_list[index], 19 );
    temp[20] = '\0';
    if( ((1<<index)&world.zone[cur_zone].object[cur_object].value[1]) )
      temp[0] = '';
    else
      temp[0] = ' ';

    return temp;
}

char *key_lister( int index, int *list_size )
{
    int j, k;

    if( index < 0 ){
      *list_size = 0;
      for( j = 0; j < world.zone[cur_zone].num_objects; j++ ){
         if( world.zone[cur_zone].object[j].type == 17 )
           *list_size = *list_size + 1;
         }
      return blankstr;
      }

    k = -1;
    for( j = 0; j < world.zone[cur_zone].num_objects; j++ ){
       if( world.zone[cur_zone].object[j].type == 17 )
         k++;
       if( k == index ){
         return world.zone[cur_zone].object[j].short_desc;
         }
       }

    return blankstr;
}

char *liquid_lister( int index, int *list_size )
{
    if( index < 0 ){
      *list_size = 16;
      return NULL;
      }

    return liquid_list[index];
}

int object_type_list_proc( int msg, DIALOG *d, int c )
{
    int ret = d_list_proc( msg, d, c ), j;

    if( cur_object > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_DCLICK ){
        world.zone[cur_zone].object[cur_object].type = d->d1;
        for( j = 0; j < 4; j++ ){
           world.zone[cur_zone].object[cur_object].value[j] = 0;
           }
        return D_REDRAW;
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

int object_type_label( int msg, DIALOG *d, int c )
{
    int ret = D_O_K;

    if( cur_object >= 0 ){
      d->dp = object_type_labels[world.zone[cur_zone].object[cur_object].type][(int)(d->dp3)];
      ret = d_rtext_proc( msg, d, c );
      }
    else{
      }

    return ret;
}

int d_mydroplistbutton_proc( int msg, DIALOG *d, int c )
{
    int ret;
    typedef char *(*getfuncptr)(int, int *);

    ret = d_button_proc( msg, d, c );

    if( ret == D_EXIT ){
      object_droplist_dlg[0].x = d->x;
      object_droplist_dlg[0].y = d->y+d->h;
      object_droplist_dlg[0].w = d->w;
      object_droplist_dlg[0].dp = object_type_proc_data[world.zone[cur_zone].object[cur_object].type][(int)(d->dp3)];
      do_dialog( object_droplist_dlg, 0 );
      if( object_type_proc_data[world.zone[cur_zone].object[cur_object].type][(int)(d->dp3)] == key_lister ){
        world.zone[cur_zone].object[cur_object].value[(int)(d->dp3)] = find_object_short_desc_zone( &world.zone[cur_zone], (*(getfuncptr)object_type_proc_data[world.zone[cur_zone].object[cur_object].type][(int)(d->dp3)])( object_droplist_dlg[0].d1, NULL ) )->vnum;
        }
      else{
        world.zone[cur_zone].object[cur_object].value[(int)(d->dp3)] = object_droplist_dlg[0].d1;
        }
      return D_REDRAW;
      }

    return ret;
}

int value_numeral_edit_proc( int msg, DIALOG *d, int c )
{
    int ret=D_O_K;

    if( msg == MSG_UCHAR ){
      if (((c >= '0') && (c <= '9')) || (c == '-')) {
        ret = d_edit_proc( msg, d, c );
        }
      }
    else{
      ret = d_edit_proc( msg, d, c );
      }

    if( ret == D_USED_CHAR ){
      world.zone[cur_zone].object[cur_object].value[(int)(d->dp3)] = atoi( d->dp );
      }

    return ret;
}

int object_type_proc( int msg, DIALOG *d, int c )
{
    int ret = D_O_K, j, k;

    if( cur_object >= 0 ){
      switch( object_type_procs[world.zone[cur_zone].object[cur_object].type][(int)(d->dp3)] ){
        case OTP_NUM:
             ret = value_numeral_edit_proc( msg, d, c );
             break;

        case OTP_DROPLIST:
             if( object_type_proc_data[world.zone[cur_zone].object[cur_object].type][(int)(d->dp3)] == key_lister &&
                 msg == MSG_DRAW ){
               d->dp = find_object_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].object[cur_object].value[(int)(d->dp3)] )->short_desc;
               }
             ret = d_mydroplistbutton_proc( msg, d, c );
             break;

        case OTP_DROPCHECK:
             ret = d_list_proc( msg, d, c );
             if( ret == D_EXIT ){
               if( (world.zone[cur_zone].object[cur_object].value[(int)(d->dp3)]&(1<<d->d1)) )
                 world.zone[cur_zone].object[cur_object].value[(int)(d->dp3)] &= ~(1<<d->d1);
               else
                 world.zone[cur_zone].object[cur_object].value[(int)(d->dp3)] |= (1<<d->d1);
               d->proc( MSG_DRAW, d, c );
               ret = D_O_K;
               }
             break;

        case OTP_CHECK:
             ret = d_check_proc( msg, d, c );
             if( msg == MSG_CLICK ){
               if( (d->flags&D_SELECTED) )
                 world.zone[cur_zone].object[cur_object].value[(int)(d->dp3)] = TRUE;
               else
                 world.zone[cur_zone].object[cur_object].value[(int)(d->dp3)] = FALSE;
               }
             break;

        case OTP_OBJPICKER:
             ret = d_mydroplistbutton_proc( msg, d, c );
             if( ret == D_REDRAW ){
               k = -1;
               for( j = 0; j < world.zone[cur_zone].num_objects; j++ ){
                  if( world.zone[cur_zone].object[j].type == 17 )
                    k++;
                  if( k == world.zone[cur_zone].object[cur_object].value[(int)(d->dp3)] ){
                    world.zone[cur_zone].object[cur_object].value[(int)(d->dp3)] = j;
                    return ret;
                    }
                  }
               }
             break;
        }
      }

    return ret;
}

int obj_shdesc_proc( int msg, DIALOG *d, int c )
{
    int ret = d_edit_proc( msg, d, c );

    if( ret == D_USED_CHAR ){
      obj_ed_dlg[3].proc( MSG_DRAW, &obj_ed_dlg[3], NULL );
      }

    return ret;
}

int obj_ed_refresher( int msg, DIALOG *d, int c )
{
    int j;
    typedef char *(*getfuncptr)(int, int *);
    static char strings[5][21]={"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",
                                "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",
                                "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",
                                "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"};

    d = NULL;
    c = 0;

greyer_thing_code

    if( msg == MSG_DRAW ){
      if( world.zone[cur_zone].num_objects == 0 ){
        obj_ed_dlg[6].flags  |= D_DISABLED;
        obj_ed_dlg[8].flags  |= D_DISABLED;
        obj_ed_dlg[10].flags |= D_DISABLED;
        obj_ed_dlg[12].flags |= D_DISABLED;
        obj_ed_dlg[14].flags |= D_DISABLED;
        obj_ed_dlg[16].flags |= D_DISABLED;
        obj_ed_dlg[18].flags |= D_DISABLED;
        obj_ed_dlg[38].flags |= D_DISABLED;

        obj_ed_dlg[6].dp  = blankstr;
        obj_ed_dlg[8].dp  = blankstr;
        obj_ed_dlg[10].dp = blankstr;
        obj_ed_dlg[12].dp = blankstr;
        strcpy( obj_ed_dlg[14].dp, "          " );
        strcpy( obj_ed_dlg[16].dp, "          " );
        strcpy( obj_ed_dlg[18].dp, "          " );
        strcpy( obj_ed_dlg[44].dp, "          " );
        obj_ed_dlg[36].dp = blankstr;
        obj_ed_dlg[38].dp = blankstr;
        return D_O_K;
        }
      else{
        if( world.zone[cur_zone].object[cur_object].num_exd == 0 ){
          obj_ed_dlg[38].flags |= D_DISABLED;
          }
        else{
          obj_ed_dlg[38].flags &= ~D_DISABLED;
          }
        if( (obj_ed_dlg[6].flags & D_DISABLED) ){
          cur_object = 0;
          obj_ed_dlg[6].flags  &= ~D_DISABLED;
          obj_ed_dlg[8].flags  &= ~D_DISABLED;
          obj_ed_dlg[10].flags &= ~D_DISABLED;
          obj_ed_dlg[12].flags &= ~D_DISABLED;
          obj_ed_dlg[14].flags &= ~D_DISABLED;
          obj_ed_dlg[16].flags &= ~D_DISABLED;
          obj_ed_dlg[18].flags &= ~D_DISABLED;
          }
        }
      obj_ed_dlg[6].dp  = world.zone[cur_zone].object[cur_object].short_desc;
      obj_ed_dlg[8].dp  = world.zone[cur_zone].object[cur_object].long_desc;
      obj_ed_dlg[10].dp = world.zone[cur_zone].object[cur_object].action_desc;
      obj_ed_dlg[12].dp = world.zone[cur_zone].object[cur_object].keywords;
      sprintf( obj_ed_dlg[14].dp, "%d", world.zone[cur_zone].object[cur_object].weight );
      sprintf( obj_ed_dlg[16].dp, "%d", world.zone[cur_zone].object[cur_object].cost );
      sprintf( obj_ed_dlg[18].dp, "%d", world.zone[cur_zone].object[cur_object].rpd );
      if( world.zone[cur_zone].object[cur_object].num_affect > 0 )
        sprintf( obj_ed_dlg[44].dp, "%d", world.zone[cur_zone].object[cur_object].affect[obj_ed_dlg[40].d1].value );
      else
        sprintf( obj_ed_dlg[44].dp, "0" );
//      ((int *)obj_ed_dlg[14].dp2) = &world.zone[cur_zone].object[cur_object].weight;
//      ((int *)obj_ed_dlg[16].dp2) = &world.zone[cur_zone].object[cur_object].cost;
//      ((int *)obj_ed_dlg[18].dp2) = &world.zone[cur_zone].object[cur_object].rpd;
      if( world.zone[cur_zone].object[cur_object].num_exd > 0 ){
        obj_ed_dlg[36].dp = world.zone[cur_zone].object[cur_object].exd[obj_ed_dlg[34].d1].keywords;
        obj_ed_dlg[38].dp = world.zone[cur_zone].object[cur_object].exd[obj_ed_dlg[34].d1].desc;
        obj_ed_dlg[38].flags &= ~D_DISABLED;
        }
      else{
        obj_ed_dlg[36].dp = blankstr;
        obj_ed_dlg[38].dp = blankstr;
        obj_ed_dlg[38].flags |= D_DISABLED;
        }
      for( j = 26; j <= 32; j+=2 ){
         switch( object_type_procs[world.zone[cur_zone].object[cur_object].type][(int)(obj_ed_dlg[j].dp3)] ){
           case OTP_NU:
                obj_ed_dlg[j].dp = NULL;
                obj_ed_dlg[j].bg = makecol( 175, 190, 175 );
                obj_ed_dlg[j].d1 = 0;
                obj_ed_dlg[j].flags = 0;
                break;

           case OTP_NUM:
                obj_ed_dlg[j].dp = strings[(j-26)/2];
                sprintf( strings[(j-26)/2], "%d", world.zone[cur_zone].object[cur_object].value[(int)(obj_ed_dlg[j].dp3)] );
                obj_ed_dlg[j].bg = makecol( 150, 175, 150 );
                obj_ed_dlg[j].d1 = 20;
                obj_ed_dlg[j].flags = 0;
                break;

           case OTP_DROPLIST:
                obj_ed_dlg[j].dp = (*(getfuncptr)object_type_proc_data[world.zone[cur_zone].object[cur_object].type][(int)(obj_ed_dlg[j].dp3)])( world.zone[cur_zone].object[cur_object].value[(int)(obj_ed_dlg[j].dp3)], NULL );
                obj_ed_dlg[j].bg = makecol( 175, 190, 175 );
                obj_ed_dlg[j].d1 = 0;
                obj_ed_dlg[j].flags = D_EXIT;
                break;

           case OTP_DROPCHECK:
                obj_ed_dlg[j].dp = object_type_proc_data[world.zone[cur_zone].object[cur_object].type][(int)(obj_ed_dlg[j].dp3)];
                obj_ed_dlg[j].bg = makecol( 175, 190, 175 );
                obj_ed_dlg[j].d1 = 0;
                obj_ed_dlg[j].flags = D_EXIT;
                break;

           case OTP_CHECK:
                obj_ed_dlg[j].dp = blankstr;
                obj_ed_dlg[j].bg = makecol( 175, 190, 175 );
                obj_ed_dlg[j].d1 = 1;
                obj_ed_dlg[j].d2 = 1;
                if( world.zone[cur_zone].object[cur_object].value[(int)(obj_ed_dlg[j].dp3)] ){
                  obj_ed_dlg[j].flags = D_SELECTED;
                  }
                else{
                  obj_ed_dlg[j].flags = 0;
                  }
                break;

           case OTP_OBJPICKER:
                if( world.zone[cur_zone].object[cur_object].value[(int)(obj_ed_dlg[j].dp3)] >= 0 )
                  obj_ed_dlg[j].dp = world.zone[cur_zone].object[world.zone[cur_zone].object[cur_object].value[(int)(obj_ed_dlg[j].dp3)]].short_desc;
                else
                  obj_ed_dlg[j].dp = blankstr;
                obj_ed_dlg[j].bg = makecol( 175, 190, 175 );
                obj_ed_dlg[j].d1 = 0;
                obj_ed_dlg[j].flags = D_EXIT;
                break;
           }
         }
      }

    return D_O_K;
}

int obj_ed()
{
    if( world.zone[cur_zone].num_objects < 1 ||
        cur_object >= world.zone[cur_zone].num_objects ){
      cur_object = -1;
      }

    do_dialog( obj_ed_dlg, 0 );

    return D_REDRAW;
}

int obj_ed_init()
{
    set_colors( obj_ed_dlg );
    set_colors( object_droplist_dlg );
    centre_dialog( obj_ed_dlg );

    return 0;
}
