#include <allegro.h>      /* Allegro rules!!! */
#include <string.h>
#include <stdio.h>
#include "genproc.h"

/* d_num_edit_proc:
 *   Wrapper for the standard edit proc that only allows numbers and a
 * minus sign to be entered, with every change it automatically updates
 * an integer pointed to by dp2
 ***/
int d_num_edit_proc( int msg, DIALOG *d, int c )
{
    int ret=D_O_K;
    int *tmp;

    if( msg == MSG_UCHAR ){
      if (((c >= '0') && (c <= '9')) || (c == '-')) {
        ret = d_edit_proc( msg, d, c );
        }
      }
    else{
      ret = d_edit_proc( msg, d, c );
      }

    if( ret == D_USED_CHAR ){
      tmp = d->dp2;
      *tmp = atoi( d->dp );
      }

    return ret;
}

/* d_fnum_edit_proc:
 *   Wrapper for the standard edit proc that only allows numbers and a
 * minus sign to be entered, with every change it automatically updates
 * a float pointed to by dp2
 ***/
int d_fnum_edit_proc( int msg, DIALOG *d, int c )
{
    int ret=D_O_K;
    float *tmp;

    if( msg == MSG_UCHAR ){
      if (((c >= '0') && (c <= '9')) || (c == '-') || (c == '.')) {
        ret = d_edit_proc( msg, d, c );
        }
      }
    else{
      ret = d_edit_proc( msg, d, c );
      }

    if( ret == D_USED_CHAR ){
      tmp = d->dp2;
      *tmp = (float)(atof( d->dp ));
      }

    return ret;
}

/* d_menubutton_proc:
 *   Wraps the standard button, but drops down a menu when clicked.  The menu
 * is pointed to by dp2, and an integer, which stores the item selected from
 * the menu, is pointed to by dp3
 ***/
int d_menubutton_proc( int msg, DIALOG *d, int c )
{
    int ret;
    int *tmp;

    ret = d_button_proc( msg, d, c );
    if( ret == D_EXIT ) {
      tmp = d->dp3;
      *tmp = do_menu( d->dp2, d->x, d->y+d->h );
      *tmp = MAX( 0, *tmp );
      d->dp = ((MENU *)d->dp2)[*tmp].text;
      ret = D_REDRAW;
      }

    return ret;
}

/* Standard dialog chunks is somthing that is needed in yfmuded, if we don't
 * have it defined we'll define a dummy so everything is still happy...
 ***/

#ifndef standarnd_dialog_chunks
# define standarnd_dialog_chunks { NULL,                    0,   0,   0,   0,   0,   0,   0,   0,      0,          0,  NULL,                    NULL,             NULL }
#endif

DIALOG droplist_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,                      dp2,              dp3 */
/*00*/{ d_list_proc,             0,   0,   192, 76,  0,   0,   0,   D_EXIT, 0,          0,  NULL,                    NULL,             NULL },
standarnd_dialog_chunks
};

/* d_droplistbutton_proc:
 *  Just like above except uses a listbox (and listbox data-getting-routine)
 * so it will scroll, but you have to double click to exit...
 ***/
int d_droplistbutton_proc( int msg, DIALOG *d, int c )
{
    int ret;
    typedef char *(*getfuncptr)(int, int *);

    ret = d_button_proc( msg, d, c );

    if( ret == D_EXIT ){
      droplist_dlg[0].x = d->x;
      droplist_dlg[0].y = d->y+d->h;
      droplist_dlg[0].w = d->w;
      droplist_dlg[0].fg = d->fg;
      droplist_dlg[0].bg = d->bg;
      droplist_dlg[0].d1 = d->d1;
      droplist_dlg[0].d2 = d->d2;
      droplist_dlg[0].dp = d->dp2;
      do_dialog( droplist_dlg, 0 );
      d->dp = (*(getfuncptr)d->dp2)(droplist_dlg[0].d1, 0);
      d->d1 = droplist_dlg[0].d1;
      d->d2 = droplist_dlg[0].d2;
      return D_REDRAW;
      }

    return ret;
}

